
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "user.y"

/*
    mmorph, MULTEXT morphology tool
    Version 2.3, October 1995
    Copyright (c) 1994,1995 ISSCO/SUISSETRA, Geneva, Switzerland
    Dominique Petitpierre, <petitp@divsun.unige.ch>
*/
#include "user.h"
#include "parse.h"

s_symbol	*defined_symbol;
static s_symbol	*largest_type_sym;
static t_card		 largest_type_card;
e_symbol_kind    defined_kind;
static s_symbol_set	*value_set;
static s_symbol_set	*variable_set;
static t_boolean	 variable_allowed;
static s_symbol	*current_attribute;
static s_type		*current_type;
static s_rule		*current_rule;
static s_tfs		*current_tfs;
static s_tfs		*common_tfs;
static s_chain		*current_chain;
static s_chain		*affix_tree_chain;
static int		 var_map_card;
static t_letter 	 *current_string;
static t_letter	 *current_base_form;
e_symbol_kind    current_letter_kind;
static s_pair		*current_pair;
static t_flag		 class_flags;
static t_flag		 current_pair_flags;
static int		 current_pair_width;
static s_bitmap	 *current_class;
static s_symbol	  fake_symbol;	/* used for pointing defined_symbol to */
static s_spell_instance *current_spell;
static s_bitmap	 *current_lexical_set;
static int		 current_pattern_length;
static s_chain		 *current_pattern;
static t_boolean	 within_focus;
static t_boolean	 has_concat_pos;

#define LETTER_STRING_SIZE_MAX	128
static t_letter	letter_string[LETTER_STRING_SIZE_MAX]; /* temp storage */
static int		letter_string_size; /* size of data in letter_string */


/* Line 189 of yacc.c  */
#line 120 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ANY = 258,
     BAR = 259,
     BIARROW = 260,
     WORDBOUNDARY = 261,
     CONTEXTBOUNDARY = 262,
     CONCATBOUNDARY = 263,
     MORPHEMEBOUNDARY = 264,
     DOLLAR = 265,
     EQUAL = 266,
     LANGLE = 267,
     LARROW = 268,
     LBRA = 269,
     NOTEQUAL = 270,
     RANGLE = 271,
     RARROW = 272,
     RBRA = 273,
     COERCEARROW = 274,
     COLON = 275,
     SLASH = 276,
     ALPHABETS = 277,
     ATTRIBUTES = 278,
     CLASSES = 279,
     GRAMMAR = 280,
     LEXICON = 281,
     PAIRS = 282,
     SPELLING = 283,
     TYPES = 284,
     DNAME = 285,
     NAME = 286,
     STRING = 287,
     SNAME = 288,
     TNAME = 289,
     LSTRING = 290
   };
#endif
/* Tokens.  */
#define ANY 258
#define BAR 259
#define BIARROW 260
#define WORDBOUNDARY 261
#define CONTEXTBOUNDARY 262
#define CONCATBOUNDARY 263
#define MORPHEMEBOUNDARY 264
#define DOLLAR 265
#define EQUAL 266
#define LANGLE 267
#define LARROW 268
#define LBRA 269
#define NOTEQUAL 270
#define RANGLE 271
#define RARROW 272
#define RBRA 273
#define COERCEARROW 274
#define COLON 275
#define SLASH 276
#define ALPHABETS 277
#define ATTRIBUTES 278
#define CLASSES 279
#define GRAMMAR 280
#define LEXICON 281
#define PAIRS 282
#define SPELLING 283
#define TYPES 284
#define DNAME 285
#define NAME 286
#define STRING 287
#define SNAME 288
#define TNAME 289
#define LSTRING 290




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 47 "user.y"

    t_str	string;
    s_symbol	*symbol;
    s_chain	*chain;
    t_value	value;
    s_tfs	*tfs;
    s_var_map	*var_map;
    t_letter	*letter_string;
    s_pair	*pair;
    


/* Line 214 of yacc.c  */
#line 239 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 251 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   142

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  36
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  93
/* YYNRULES -- Number of rules.  */
#define YYNRULES  139
/* YYNRULES -- Number of states.  */
#define YYNSTATES  193

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   290

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,    12,    15,    17,    21,    23,    25,    28,
      30,    35,    38,    39,    41,    43,    45,    48,    50,    54,
      58,    60,    62,    64,    66,    68,    70,    73,    75,    79,
      82,    84,    88,    93,    95,    97,   100,   103,   106,   108,
     111,   113,   116,   119,   122,   125,   128,   130,   133,   135,
     138,   140,   143,   145,   148,   149,   152,   153,   156,   158,
     161,   162,   164,   172,   174,   177,   179,   181,   183,   187,
     189,   191,   193,   196,   197,   200,   202,   204,   205,   207,
     209,   211,   213,   215,   216,   220,   223,   225,   227,   230,
     232,   235,   237,   240,   243,   244,   246,   249,   250,   253,
     255,   262,   264,   266,   269,   271,   273,   275,   278,   279,
     281,   284,   286,   290,   292,   295,   297,   301,   303,   307,
     309,   311,   313,   315,   319,   321,   323,   325,   328,   329,
     332,   333,   335,   338,   340,   344,   346,   349,   351,   353
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      37,     0,    -1,   102,    38,    43,    50,   122,   109,    78,
      91,    -1,    39,    71,    -1,    23,    -1,    41,    20,    72,
      -1,    30,    -1,    31,    -1,    44,    73,    -1,    29,    -1,
      48,    20,    77,    46,    -1,    47,    77,    -1,    -1,     4,
      -1,    30,    -1,    31,    -1,    51,    74,    -1,    25,    -1,
      57,    20,    53,    -1,    55,    54,    69,    -1,    70,    -1,
      58,    -1,    13,    -1,    58,    -1,    35,    -1,    30,    -1,
      59,    60,    -1,    34,    -1,    14,    75,    18,    -1,    49,
      62,    -1,    64,    -1,    11,    10,    63,    -1,    11,    10,
      63,    64,    -1,    31,    -1,    65,    -1,    15,    66,    -1,
      11,    66,    -1,    67,    76,    -1,    31,    -1,     4,    67,
      -1,    55,    -1,    55,    55,    -1,    70,    55,    -1,    55,
      70,    -1,    56,    58,    -1,    71,    40,    -1,    40,    -1,
      72,    42,    -1,    42,    -1,    73,    45,    -1,    45,    -1,
      74,    52,    -1,    52,    -1,    75,    61,    -1,    -1,    76,
      68,    -1,    -1,    77,    49,    -1,    49,    -1,    79,    82,
      -1,    -1,    28,    -1,    81,    20,    86,    83,    85,    84,
      87,    -1,    30,    -1,    82,    80,    -1,    80,    -1,    89,
      -1,    89,    -1,     7,    88,     7,    -1,    17,    -1,     5,
      -1,    19,    -1,    87,    58,    -1,    -1,    88,    90,    -1,
      90,    -1,    88,    -1,    -1,     8,    -1,     9,    -1,     6,
      -1,   116,    -1,    92,    -1,    -1,    92,    93,   101,    -1,
      94,   101,    -1,    26,    -1,    26,    -1,    96,    97,    -1,
      58,    -1,    97,    98,    -1,    98,    -1,   100,    99,    -1,
      11,    35,    -1,    -1,    35,    -1,   101,    95,    -1,    -1,
     103,   104,    -1,    22,    -1,   105,    20,   107,   106,    20,
     107,    -1,    30,    -1,    30,    -1,   107,   108,    -1,   108,
      -1,    31,    -1,    32,    -1,   110,   111,    -1,    -1,    27,
      -1,   111,   112,    -1,   112,    -1,   113,    20,   114,    -1,
      30,    -1,   114,   115,    -1,   115,    -1,   118,    21,   119,
      -1,   117,    -1,   118,    21,   119,    -1,   117,    -1,    31,
      -1,   120,    -1,   120,    -1,    12,   121,    16,    -1,    35,
      -1,    31,    -1,     3,    -1,   121,    31,    -1,    -1,   123,
     124,    -1,    -1,    24,    -1,   124,   125,    -1,   125,    -1,
     126,    20,   127,    -1,    30,    -1,   127,   128,    -1,   128,
      -1,    31,    -1,    32,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   141,   141,   148,   157,   165,   173,   183,   191,   213,
     222,   240,   244,   248,   254,   264,   272,   283,   293,   299,
     305,   311,   325,   331,   337,   344,   353,   368,   381,   387,
     393,   397,   401,   407,   439,   456,   463,   469,   475,   482,
     488,   494,   500,   506,   514,   523,   527,   533,   537,   543,
     547,   553,   557,   563,   570,   576,   581,   586,   594,   604,
     615,   619,   627,   646,   665,   669,   675,   687,   694,   706,
     710,   714,   721,   727,   733,   736,   741,   745,   749,   760,
     767,   774,   783,   787,   791,   795,   800,   805,   823,   833,
     846,   849,   854,   879,   885,   890,   896,   901,   906,   913,
     950,   961,   974,   989,   992,   997,  1012,  1035,  1044,  1048,
    1056,  1060,  1065,  1071,  1085,  1088,  1093,  1121,  1141,  1162,
    1171,  1183,  1191,  1199,  1204,  1208,  1233,  1239,  1248,  1254,
    1263,  1266,  1274,  1277,  1282,  1300,  1308,  1311,  1316,  1359
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ANY", "BAR", "BIARROW", "WORDBOUNDARY",
  "CONTEXTBOUNDARY", "CONCATBOUNDARY", "MORPHEMEBOUNDARY", "DOLLAR",
  "EQUAL", "LANGLE", "LARROW", "LBRA", "NOTEQUAL", "RANGLE", "RARROW",
  "RBRA", "COERCEARROW", "COLON", "SLASH", "ALPHABETS", "ATTRIBUTES",
  "CLASSES", "GRAMMAR", "LEXICON", "PAIRS", "SPELLING", "TYPES", "DNAME",
  "NAME", "STRING", "SNAME", "TNAME", "LSTRING", "$accept", "Start",
  "AttDecl", "AttHead", "AttDef", "AttNew", "ValNew", "TypeDecl",
  "TypeHead", "TypeDef", "NoProjectAttOPTL", "ProjSep", "TypeNew",
  "AttName", "GramDecl", "GramHead", "Rule", "RuleBody", "Rewrite",
  "VarTfs", "AffixString", "RuleNew", "Tfs", "TypeName", "AttSpec",
  "AttVal", "ValSpec", "VarName", "ValSetSpec", "ValSet", "ValDisj",
  "ValName", "ValDisjRest", "Rhs", "Affix", "AttDefPLUS", "ValNewPLUS",
  "TypeDefPLUS", "RulePLUS", "AttValSTAR", "ValDisjRestSTAR",
  "AttNamePLUS", "SpellDeclOPT", "SpellHead", "SpellDef", "SpellNew",
  "SpellDefPLUS", "LeftContext", "RightContext", "Focus", "Arrow",
  "ConstraintSTAR", "PatternPLUS", "PatternSTAR", "Pattern", "LexDeclSTAR",
  "LexDeclPLUS", "LexHead", "FirstLexHead", "LexDef", "CommonTfs",
  "LexicalPLUS", "Lexical", "BaseFormOPTL", "LexNew", "LexDefSTAR",
  "AlphabetDecl", "AlphabetHead", "AlphabetDef", "LexicalNew",
  "SurfaceNew", "LetterNewPLUS", "LetterNew", "PairDeclOPT", "PairHead",
  "PairDefPLUS", "PairDef", "PairNew", "PairPLUS", "Pair", "PairPattern",
  "PairName", "SurfSequence", "LexSequence", "Sequence", "LetterSTAR",
  "ClassDeclOPT", "ClassHead", "ClassDefPLUS", "ClassDef", "ClassNew",
  "ClassPLUS", "Class", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    46,    47,    48,    49,    50,    51,    52,    53,
      53,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    62,    62,    63,    64,    65,    65,    66,    67,    68,
      69,    69,    69,    69,    70,    71,    71,    72,    72,    73,
      73,    74,    74,    75,    75,    76,    76,    77,    77,    78,
      78,    79,    80,    81,    82,    82,    83,    84,    85,    86,
      86,    86,    87,    87,    88,    88,    89,    89,    90,    90,
      90,    90,    91,    91,    92,    92,    93,    94,    95,    96,
      97,    97,    98,    99,    99,   100,   101,   101,   102,   103,
     104,   105,   106,   107,   107,   108,   108,   109,   109,   110,
     111,   111,   112,   113,   114,   114,   115,   115,   116,   116,
     117,   118,   119,   120,   120,   120,   120,   121,   121,   122,
     122,   123,   124,   124,   125,   126,   127,   127,   128,   128
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     8,     2,     1,     3,     1,     1,     2,     1,
       4,     2,     0,     1,     1,     1,     2,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     2,     1,     3,     2,
       1,     3,     4,     1,     1,     2,     2,     2,     1,     2,
       1,     2,     2,     2,     2,     2,     1,     2,     1,     2,
       1,     2,     1,     2,     0,     2,     0,     2,     1,     2,
       0,     1,     7,     1,     2,     1,     1,     1,     3,     1,
       1,     1,     2,     0,     2,     1,     1,     0,     1,     1,
       1,     1,     1,     0,     3,     2,     1,     1,     2,     1,
       2,     1,     2,     2,     0,     1,     2,     0,     2,     1,
       6,     1,     1,     2,     1,     1,     1,     2,     0,     1,
       2,     1,     3,     1,     2,     1,     3,     1,     3,     1,
       1,     1,     1,     3,     1,     1,     1,     2,     0,     2,
       0,     1,     2,     1,     3,     1,     2,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,    99,     0,     0,     0,     1,     4,     0,     0,   101,
      98,     0,     9,     0,     0,     6,    46,     0,     3,     0,
      17,   130,     0,    14,    50,     0,     8,     0,    45,   105,
     106,     0,   104,   131,   108,     0,    25,    52,     0,    16,
       0,    49,     7,    48,     5,   102,     0,   103,   109,    60,
       0,   135,   129,   133,     0,     0,    51,    15,    58,    12,
      47,     0,    61,    83,     0,   113,   107,   111,     0,   132,
       0,    27,    24,    18,     0,     0,    21,     0,    20,    13,
      10,     0,    57,   100,    87,     2,    82,    97,    63,    65,
       0,    59,   110,     0,   138,   139,   134,   137,    22,     0,
      44,    54,    26,    11,    86,    97,    85,     0,    64,   126,
     128,   120,   124,   112,   115,   117,     0,   121,   136,    40,
      23,    19,     0,     0,    84,    89,    96,     0,    70,    69,
      71,    77,     0,   114,     0,    41,    43,    42,    28,     0,
      53,    95,    88,    91,    94,    80,    78,    79,     0,    76,
      66,    75,    81,   119,     0,   123,   127,   125,   116,   122,
       0,     0,    29,    30,    34,    90,     0,    92,     0,    77,
      74,     0,     0,    38,    36,    56,    35,    93,     0,    73,
      67,   118,    33,    31,    37,    68,    62,     0,    32,     0,
      55,    72,    39
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     7,     8,    16,    17,    43,    13,    14,    24,
      80,    81,    25,    58,    21,    22,    37,    73,    99,    74,
      75,    38,   120,    77,   102,   140,   162,   183,   163,   164,
     174,   175,   190,   121,    78,    18,    44,    26,    39,   123,
     184,    59,    63,    64,    89,    90,    91,   148,   179,   169,
     131,   186,   149,   150,   151,    85,    86,   105,    87,   126,
     127,   142,   143,   167,   144,   106,     3,     4,    10,    11,
      46,    31,    32,    49,    50,    66,    67,    68,   113,   114,
     152,   153,   154,   158,   117,   132,    34,    35,    52,    53,
      54,    96,    97
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -138
static const yytype_int16 yypact[] =
{
       7,  -138,    24,    35,     5,  -138,  -138,    27,    46,  -138,
    -138,    53,  -138,    38,    48,  -138,  -138,    57,    46,    29,
    -138,    55,    50,  -138,  -138,    61,    48,    51,  -138,  -138,
    -138,    40,  -138,  -138,    56,    54,  -138,  -138,    65,    50,
      58,  -138,  -138,  -138,    51,  -138,    66,  -138,  -138,    59,
      60,  -138,    54,  -138,    68,    33,  -138,  -138,  -138,    19,
    -138,    29,  -138,    67,    62,  -138,    60,  -138,    71,  -138,
      43,  -138,  -138,  -138,    81,    63,    82,    84,  -138,  -138,
    -138,    58,  -138,    29,  -138,  -138,    70,  -138,  -138,  -138,
      79,    62,  -138,     2,  -138,  -138,    43,  -138,  -138,    33,
    -138,  -138,  -138,    58,  -138,  -138,    63,    47,  -138,  -138,
    -138,    80,  -138,     2,  -138,  -138,    83,  -138,  -138,    33,
    -138,  -138,    63,    -1,    63,  -138,  -138,    72,  -138,  -138,
    -138,    13,    12,  -138,     3,  -138,  -138,  -138,  -138,    42,
    -138,  -138,    72,  -138,    89,  -138,  -138,  -138,    95,    13,
    -138,  -138,  -138,  -138,    85,  -138,  -138,  -138,  -138,  -138,
       8,    74,  -138,  -138,  -138,  -138,    73,  -138,    13,    13,
    -138,     3,    78,  -138,  -138,  -138,  -138,  -138,     1,  -138,
    -138,  -138,  -138,    44,    99,  -138,    63,    74,  -138,    74,
    -138,  -138,  -138
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -138,  -138,  -138,  -138,    92,  -138,    69,  -138,  -138,    86,
    -138,  -138,  -138,   -58,  -138,  -138,    75,  -138,  -138,   -73,
    -138,  -138,   -55,  -138,  -138,  -138,  -138,  -138,   -72,  -138,
     -46,   -71,  -138,  -138,   -88,  -138,  -138,  -138,  -138,  -138,
    -138,    36,  -138,  -138,    25,  -138,  -138,  -138,  -138,  -138,
    -138,  -138,   -49,   -48,  -137,  -138,  -138,  -138,  -138,  -138,
    -138,  -138,   -22,  -138,  -138,    17,  -138,  -138,  -138,  -138,
    -138,    64,   -29,  -138,  -138,  -138,    76,  -138,  -138,    10,
    -138,   -66,   -51,   -47,  -131,  -138,  -138,  -138,  -138,    77,
    -138,  -138,    30
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -126
static const yytype_int16 yytable[] =
{
      76,    82,    47,   159,   109,   109,   109,   145,   185,   146,
     147,   122,   170,   110,   110,   110,   109,   138,   172,   145,
     100,   146,   147,    79,     5,   110,   119,   115,   155,     1,
      57,   136,   111,   111,   157,     9,   112,   112,   112,   173,
     159,   170,   116,   156,   111,    82,   135,   115,   112,   137,
      57,   125,   128,   160,    47,   187,    12,   161,     6,   161,
      29,    30,   116,    20,   129,   139,   130,    71,    72,   125,
      45,    29,    30,    19,    94,    95,    15,    27,    23,    33,
      36,    40,    42,    48,    51,    55,    61,    62,    70,    57,
      65,    93,    88,    84,    98,   -23,   104,    71,   101,   107,
     166,  -125,   168,   189,   134,   173,   171,   141,   177,   182,
      28,   188,    41,    60,    56,   176,   108,   103,   192,   178,
     165,   180,   124,   133,   181,    83,   118,     0,     0,    69,
       0,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    92
};

static const yytype_int16 yycheck[] =
{
      55,    59,    31,   134,     3,     3,     3,     6,     7,     8,
       9,    99,   149,    12,    12,    12,     3,    18,    10,     6,
      75,     8,     9,     4,     0,    12,    99,    93,    16,    22,
      31,   119,    31,    31,    31,    30,    35,    35,    35,    31,
     171,   178,    93,    31,    31,   103,   119,   113,    35,   122,
      31,   106,     5,    11,    83,    11,    29,    15,    23,    15,
      31,    32,   113,    25,    17,   123,    19,    34,    35,   124,
      30,    31,    32,    20,    31,    32,    30,    20,    30,    24,
      30,    20,    31,    27,    30,    20,    20,    28,    20,    31,
      30,    20,    30,    26,    13,    13,    26,    34,    14,    20,
      11,    21,     7,     4,    21,    31,    21,    35,    35,    31,
      18,   183,    26,    44,    39,   161,    91,    81,   189,   168,
     142,   169,   105,   113,   171,    61,    96,    -1,    -1,    52,
      -1,   186,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    66
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    22,    37,   102,   103,     0,    23,    38,    39,    30,
     104,   105,    29,    43,    44,    30,    40,    41,    71,    20,
      25,    50,    51,    30,    45,    48,    73,    20,    40,    31,
      32,   107,   108,    24,   122,   123,    30,    52,    57,    74,
      20,    45,    31,    42,    72,    30,   106,   108,    27,   109,
     110,    30,   124,   125,   126,    20,    52,    31,    49,    77,
      42,    20,    28,    78,    79,    30,   111,   112,   113,   125,
      20,    34,    35,    53,    55,    56,    58,    59,    70,     4,
      46,    47,    49,   107,    26,    91,    92,    94,    30,    80,
      81,    82,   112,    20,    31,    32,   127,   128,    13,    54,
      58,    14,    60,    77,    26,    93,   101,    20,    80,     3,
      12,    31,    35,   114,   115,   117,   118,   120,   128,    55,
      58,    69,    70,    75,   101,    58,    95,    96,     5,    17,
      19,    86,   121,   115,    21,    55,    70,    55,    18,    49,
      61,    35,    97,    98,   100,     6,     8,     9,    83,    88,
      89,    90,   116,   117,   118,    16,    31,    31,   119,   120,
      11,    15,    62,    64,    65,    98,    11,    99,     7,    85,
      90,    21,    10,    31,    66,    67,    66,    35,    88,    84,
      89,   119,    31,    63,    76,     7,    87,    11,    64,     4,
      68,    58,    67
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 143 "user.y"
    {

	}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 149 "user.y"
    {
	    defined_symbol=NULL; /* end of definitions */
	    make_symbol_reference(&symbol_set[Attribute]);
	    if (debug & DEBUG_INIT)
		print_symbols_by_ref(&symbol_set[Attribute]);
	}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 158 "user.y"
    {
	    defined_kind=Attribute;
	    crc32file_addn(&crc, (unsigned char *) "@Attributes ",
			   sizeof("@Attributes "));
	}
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 166 "user.y"
    {
	    make_symbol_reference(value_set);
	    link_attribute(value_set,(yyvsp[(1) - (3)].symbol));
	    defined_symbol=NULL; /* for error message */
	}
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 174 "user.y"
    {
	    (yyval.symbol)=*new_symbol((yyvsp[(1) - (1)].string),&symbol_set[Attribute]);
	    value_set=&(yyval.symbol)->data->attribute.value_set;
	    defined_symbol=(yyval.symbol);
	    crc32file_addn(&crc, (unsigned char *) (yyvsp[(1) - (1)].string), (int) strlen((yyvsp[(1) - (1)].string)));
	    crc32file_add(&crc, (unsigned char) ':');
	}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 184 "user.y"
    {
	    (void) new_symbol((yyvsp[(1) - (1)].string),value_set);
	    crc32file_addn(&crc, (unsigned char *) (yyvsp[(1) - (1)].string), (int) strlen((yyvsp[(1) - (1)].string)));
	    crc32file_add(&crc, (unsigned char) ' ');
	}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 192 "user.y"
    {
	    defined_symbol=NULL; /* end of definitions */
	    make_symbol_reference(&symbol_set[Type]);
	    largest_type=largest_type_sym->ordinal;
	    if (debug & DEBUG_INIT)
		print_symbols_by_ref(&symbol_set[Type]);
	    /* TODO: move this to end of spelling rules
               when looking up unknown words works.
	     */
	    if (db_operation & Lookup) {
		crc32file_hash(&crc, crc_hash);
		parsing=FALSE; /* change format of fatal errors */
		tfs_table_init(db_operation, gram_file_name, db_file_name,
			       crc_hash);
		parsing=TRUE;
	    }
	    if (db_operation == Lookup)
		YYACCEPT; /* skip the rest of the file */
	}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 214 "user.y"
    {
	    defined_kind=Type;
	    largest_type_card = 0;
	    crc32file_addn(&crc, (unsigned char *) "@Types ",
			   sizeof("@Types "));
	}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 223 "user.y"
    {
	    if (current_type->project_card==0)
		current_type->project_card=current_type->card;
	    if (current_type->card > largest_type_card) {
		largest_type_sym = defined_symbol;
		largest_type_card = current_type->card;
	    }
	    current_type->attribute_ref=
		  (s_symbol **) new_ref((int) current_type->card,
					 map_chain,
					 (t_ptr) current_chain,
					 ref_is_item);
	    free_chain(current_chain);
	    defined_symbol=NULL; /* for error message */
	}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 241 "user.y"
    {
		}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 244 "user.y"
    {
		}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 249 "user.y"
    {
	    current_type->project_card= current_type->card;
	    crc32file_add(&crc, (unsigned char) '|');
	}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 255 "user.y"
    {
	    defined_symbol = *new_symbol((yyvsp[(1) - (1)].string),&symbol_set[Type]);
	    current_type = (s_type *) defined_symbol->data;
	    current_chain = NULL;
	    crc32file_addn(&crc, (unsigned char *) (yyvsp[(1) - (1)].string), (int) strlen((yyvsp[(1) - (1)].string)));
	    crc32file_add(&crc, (unsigned char) ':');
	}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 265 "user.y"
    {
	    (yyval.symbol)=*find_symbol((yyvsp[(1) - (1)].string),&symbol_set[Attribute]);
	    current_attribute=(yyval.symbol);
	    value_set= &(((yyval.symbol))->data->attribute.value_set);
	}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 273 "user.y"
    {
	    defined_symbol=NULL; /* end of definitions */
	    make_symbol_reference(&symbol_set[Rule]);
	    if (debug & DEBUG_INIT)
		print_symbols_by_ref(&symbol_set[Rule]);
	    if (! parse_only)
		prepare_rules();
	}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 284 "user.y"
    {
	    defined_kind=Rule;
	    goal_card = 0;
	    /* tell tokenizer to interpret strings as lexical strings */
	    current_letter_kind=Lexical_Letter;
	    current_letter_map=lexical_letter_map;
	}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 294 "user.y"
    {
	    defined_symbol=NULL; /* for error message */
	}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 300 "user.y"
    {
		make_symbol_reference(variable_set);
		current_rule->instance->lhs=(yyvsp[(1) - (3)].tfs);
		adjust_var_map(variable_set->ref,current_rule->instance);
	    }
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 306 "user.y"
    {
		variable_set = NULL; /* no variable to handle */
		current_rule->instance->rule_kind = Lexical;
		current_rule->instance->lhs=(yyvsp[(1) - (1)].tfs);
	    }
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 312 "user.y"
    {
		current_rule->instance->rule_kind = Goal;
		goal_card++;
		if ((yyvsp[(1) - (1)].tfs)->var_map != NULL) /* TODO catch this earlier */
		    fatal_error("variables not allowed in goal rule");
		current_rule->instance->first=(yyvsp[(1) - (1)].tfs);
		current_rule->instance->lex= (t_letter *) "";/* empty string */
		current_rule->instance->lhs=new_tfs((yyvsp[(1) - (1)].tfs)->type);
		fill_tfs_with_variables(current_rule->instance->lhs);
		ident_var_map(current_rule->instance->lhs);
	    }
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 326 "user.y"
    {

	    }
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 332 "user.y"
    {
		(yyval.tfs)=(yyvsp[(1) - (1)].tfs);
	    }
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 338 "user.y"
    {
		variable_allowed=FALSE;
		(yyval.letter_string)=(yyvsp[(1) - (1)].letter_string);
	    }
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 345 "user.y"
    {
	    defined_symbol = *new_symbol((yyvsp[(1) - (1)].string),&symbol_set[Rule]);
	    current_rule = (s_rule *)defined_symbol->data;
	    variable_set = &(current_rule->variable_set);
	    variable_allowed=TRUE;
	}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 354 "user.y"
    {
	    (yyval.tfs) = (yyvsp[(1) - (2)].tfs); /* that's the tfs */
	    if ((yyvsp[(2) - (2)].chain) == NULL)
		(yyval.tfs)->var_map = NULL;
	    else {
		(yyval.tfs)->var_map = (s_var_map **) new_ref(var_map_card,
						     map_chain,
						     (t_ptr) (yyvsp[(2) - (2)].chain),
						     ref_is_item);
		free_chain((yyvsp[(2) - (2)].chain));
	    }
	}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 369 "user.y"
    {
	    s_symbol *symbol;

	    symbol = *find_symbol((yyvsp[(1) - (1)].string),&symbol_set[Type]);
	    current_type = (s_type *) symbol->data;
	    (yyval.tfs)=new_tfs(symbol->ordinal);
	    current_tfs=(yyval.tfs);
	    /* fill the type feature structure with full sets */
	    fill_tfs_with_variables((yyval.tfs));
	}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 382 "user.y"
    {
	    (yyval.chain)=(yyvsp[(2) - (3)].chain);
	}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 388 "user.y"
    {
	    (yyval.var_map)=(yyvsp[(2) - (2)].var_map);
	}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 394 "user.y"
    {
	    (yyval.var_map)=NULL;
	}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 398 "user.y"
    {
	    (yyval.var_map)=(yyvsp[(3) - (3)].var_map);
	}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 402 "user.y"
    {
	    (yyval.var_map)=(yyvsp[(3) - (4)].var_map);
	}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 408 "user.y"
    {
	    int pos;
	    s_symbol *variable;

	    pos = reference_position((t_ptr *) current_type->attribute_ref,
			             (t_ptr) current_attribute);
	    if ( pos < 0 )
		fatal_error(
		   "attribute \"%s\" not declared for type \"%s\"",
		    current_attribute->name,
		    symbol_set[Type].ref[current_tfs->type]->name);
	    if (! variable_allowed)
		fatal_error(
		    "a variable is not allowed in this context");
	    variable = *new_symbol((yyvsp[(1) - (1)].string),variable_set);
	    if (variable->data->variable.attribute_link == NULL)
		variable->data->variable.attribute_link=current_attribute;
	    else
		if (variable->data->variable.attribute_link
			!= current_attribute)
		    fatal_error("variable $%s %s \"%s\" and \"%s\"",
			(yyvsp[(1) - (1)].string),
			"is used for incompatible attributes:",
			variable->data->variable.attribute_link->name,
			current_attribute->name);
	    MY_MALLOC((yyval.var_map),s_var_map);
	    (yyval.var_map)->foreign_index = (t_index) variable->ordinal;
	    (yyval.var_map)->local_index = (t_index) pos;
	}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 440 "user.y"
    {
	    int pos;

	    pos = reference_position((t_ptr *) current_type->attribute_ref,
			             (t_ptr) current_attribute);
	    if ( pos < 0 )
		fatal_error(
		   "attribute \"%s\" not declared for type \"%s\"",
		    current_attribute->name,
		    symbol_set[Type].ref[current_tfs->type]->name);
	    current_tfs->att_list[pos] &= (yyvsp[(1) - (1)].value);
	    if (current_tfs->att_list[pos] == NO_BITS)
		fatal_error("value set complement for \"%s\" is empty",
			    current_attribute->name);
	}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 457 "user.y"
    {
	    (yyval.value) = ~ ((yyvsp[(2) - (2)].value));
	    if ((yyval.value) == NO_BITS)
	        /* occurs only when there is MAXVAL values for attribute */
		fatal_error("value set complement is empty");
	}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 464 "user.y"
    {
	    (yyval.value) = (yyvsp[(2) - (2)].value);
	}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 470 "user.y"
    {
	    (yyval.value) = ((yyvsp[(1) - (2)].value) | (yyvsp[(2) - (2)].value));
	}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 476 "user.y"
    {
	    
	    (yyval.value) = BIT_N((*find_symbol((yyvsp[(1) - (1)].string),value_set))->ordinal);
	}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 483 "user.y"
    {
	    (yyval.value) = (yyvsp[(2) - (2)].value);
	}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 489 "user.y"
    {
	    current_rule->instance->rule_kind=Unary;
	    current_rule->instance->first=(yyvsp[(1) - (1)].tfs);
	    current_rule->instance->second=NULL;
	}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 495 "user.y"
    {
	    current_rule->instance->rule_kind=Binary;
	    current_rule->instance->first=(yyvsp[(1) - (2)].tfs);
	    current_rule->instance->second=(yyvsp[(2) - (2)].tfs);
	}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 501 "user.y"
    {
	    current_rule->instance->rule_kind=Prefix;
	    current_rule->instance->first=(yyvsp[(2) - (2)].tfs);
	    current_rule->instance->second=(yyvsp[(1) - (2)].tfs);
	}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 507 "user.y"
    {
	    current_rule->instance->rule_kind=Suffix;
	    current_rule->instance->first=(yyvsp[(1) - (2)].tfs);
	    current_rule->instance->second=(yyvsp[(2) - (2)].tfs);
	}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 515 "user.y"
    {
	    /* affix tfs cannot have variables; see adjust_var_map() */
	    current_rule->instance->lex=(yyvsp[(1) - (2)].letter_string);
	    current_rule->instance->lex_length=strlen((char *) (yyvsp[(1) - (2)].letter_string));
	    (yyval.tfs)=(yyvsp[(2) - (2)].tfs);
	    variable_allowed = TRUE; /* useful only for prefix */
	}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 524 "user.y"
    {

	}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 528 "user.y"
    {

	}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 534 "user.y"
    {

	}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 538 "user.y"
    {

	}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 544 "user.y"
    {

	}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 548 "user.y"
    {

	}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 554 "user.y"
    {

	}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 558 "user.y"
    {

	}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 564 "user.y"
    {
	    var_map_card++;
	    if ((yyvsp[(2) - (2)].var_map) != NULL)
	        (yyval.chain) = insert_chain_link((yyvsp[(1) - (2)].chain), (t_ptr) (yyvsp[(2) - (2)].var_map));
	}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 570 "user.y"
    {
	    var_map_card=0;
	    (yyval.chain)=NULL;
	}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 577 "user.y"
    {
	    (yyval.value) = ( (yyvsp[(1) - (2)].value) | (yyvsp[(2) - (2)].value) );
	}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 581 "user.y"
    {
	    (yyval.value) = 0L;
	}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 587 "user.y"
    {
	    current_type->card++;
	    current_chain=insert_chain_link(current_chain, (t_ptr) (yyvsp[(2) - (2)].symbol));
	    crc32file_addn(&crc, (unsigned char *) (yyvsp[(2) - (2)].symbol)->name,
			   (int) strlen((yyvsp[(2) - (2)].symbol)->name));
	    crc32file_add(&crc, (unsigned char) ' ');
	}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 595 "user.y"
    {
	    current_type->card++;
	    current_chain=insert_chain_link(current_chain, (t_ptr) (yyvsp[(1) - (1)].symbol));
	    crc32file_addn(&crc, (unsigned char *) (yyvsp[(1) - (1)].symbol)->name,
			   (int) strlen((yyvsp[(1) - (1)].symbol)->name));
	    crc32file_add(&crc, (unsigned char) ' ');
	}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 605 "user.y"
    {
	    defined_symbol=NULL; /* end of definitions */
	    make_symbol_reference(&symbol_set[Spelling]);
	    if (debug & DEBUG_INIT)
		print_symbols_by_ref(&symbol_set[Spelling]);
	    max_spell_length=max_left_context_length + max_rest_length;
	    if (!parse_only)
		prepare_spell();
	}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 615 "user.y"
    {
	}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 620 "user.y"
    {
	    defined_kind=Spelling;
	    max_left_context_length=0;
	    max_rest_length=0;
	}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 629 "user.y"
    {
	    current_spell->left_context
		= reverse_chain(current_spell->left_context);
	    if (! has_concat_pos)
		current_spell->concat_pos = NO_CONCAT; /* impossible value */
	    defined_symbol=NULL; /* for error message */
	    max_left_context_length 
		= MAX(current_spell->left_context_length,
		      max_left_context_length);
	    max_rest_length 
		= MAX(current_spell->focus_length
		      + current_spell->right_context_length,
		      max_rest_length);
	    current_spell->constraint = (yyvsp[(7) - (7)].chain);
	}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 647 "user.y"
    {
	    defined_symbol = *new_symbol((yyvsp[(1) - (1)].string),&symbol_set[Spelling]);
	    current_spell
		= defined_symbol->data->spelling.instance;
	    current_spell->spell_link=defined_symbol;
	    /* next letter will be found in surface alphabet */
	    current_letter_kind=Surface_Letter;
	    current_letter_map=surface_letter_map;
	    current_pair_flags=BOTH_LETTERS; /* for next explicit Pair */
	    has_concat_pos=FALSE;
	    current_spell->concat_pos=0;
	    current_pattern=NULL; /* prepare for left context */
	    current_pattern_length=0;
	    within_focus=FALSE;
	}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 666 "user.y"
    {

	}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 670 "user.y"
    {

	}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 676 "user.y"
    {
		current_spell->left_context=current_pattern;
		current_spell->left_context_length=current_pattern_length;
		if (has_concat_pos)
		    current_spell->concat_pos -= current_pattern_length;
		current_pattern=NULL; /* prepare for focus */
		current_pattern_length=0;
		within_focus=TRUE;
	    }
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 688 "user.y"
    {
		current_spell->right_context=current_pattern;
		current_spell->right_context_length=current_pattern_length;
	    }
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 695 "user.y"
    {
		current_spell->focus = current_pattern;
		current_spell->focus_length=current_pattern_length;
		if (! has_concat_pos)
		    current_spell->concat_pos += current_pattern_length;
		current_pattern = NULL; /* prepare for right context */
		current_pattern_length=0;
		within_focus=FALSE;
	    }
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 707 "user.y"
    {
	    current_spell->kind= Optional;
	}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 711 "user.y"
    {
	    current_spell->kind= Obligatory;
	}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 715 "user.y"
    {
	    current_spell->kind = Coerce;
	}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 722 "user.y"
    {
	    (yyval.chain) = insert_chain_link((yyvsp[(1) - (2)].chain), (t_ptr) (yyvsp[(2) - (2)].tfs));
	    current_spell->constraint_card++;
	}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 727 "user.y"
    {
	    current_spell->constraint_card = 0;
	    (yyval.chain) = NULL;
	}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 734 "user.y"
    {
	    }
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 737 "user.y"
    {
	    }
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 742 "user.y"
    {
	    }
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 745 "user.y"
    {
	    }
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 750 "user.y"
    {
		if (has_concat_pos)
		    fatal_error("concatenation position already specified");
		has_concat_pos=TRUE;
		current_spell->concat_pos += current_pattern_length;
		current_pattern
		    = insert_chain_link(current_pattern,
					(t_ptr) morpheme_boundary_pair);
		current_pattern_length++;
	    }
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 761 "user.y"
    {
		current_pattern
		    = insert_chain_link(current_pattern,
					(t_ptr) morpheme_boundary_pair);
		current_pattern_length++;
	    }
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 768 "user.y"
    {
		current_pattern
		    = insert_chain_link(current_pattern,
					(t_ptr) word_boundary_pair);
		current_pattern_length++;
	    }
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 775 "user.y"
    {
		current_pattern
		    = insert_chain_link(current_pattern, (t_ptr) (yyvsp[(1) - (1)].pair));
		current_pattern_length += lexical_width((yyvsp[(1) - (1)].pair));
	    }
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 784 "user.y"
    {
		}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 787 "user.y"
    {
		}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 792 "user.y"
    {

	}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 796 "user.y"
    {
	}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 801 "user.y"
    {
	}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 806 "user.y"
    {
	    defined_kind = Lexicon;
	    variable_set=NULL; /* prevent variables in lexical Tfs */
	    variable_allowed=FALSE;
	    if ((db_operation & Update)) {
	 	/* options mentionned -a */
		augmenting=TRUE;
		initfile(augment_file_name); /* splice in file now */
	    }
	    /* otherwise splice it at the end of this file, cf tokenize.l */
	    /* tell tokenizer to interpret strings as lexical strings */
	    current_letter_kind=Lexical_Letter;
	    current_letter_map=lexical_letter_map;
	    normalize = normalize_flag;
	}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 824 "user.y"
    {
	    free_tfs(common_tfs);
	    if (! parse_only) {
		map_chain(affix_tree_chain, free_affix_tree);
		free_chain(affix_tree_chain);
	    }
	}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 834 "user.y"
    {
	    common_tfs = (yyvsp[(1) - (1)].tfs);
	    if (! parse_only)
		affix_tree_chain = build_affix_trees(common_tfs);
	    else
		if (normalize) {
		    print_out("\t");
		    print_tfs1(outfile, common_tfs, FALSE, FALSE, FALSE);
		}
	  }
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 847 "user.y"
    {
	    }
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 850 "user.y"
    {
	    }
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 855 "user.y"
    {
	    parsing=FALSE;
	    if (! parse_only)
		generate_surface(current_string, current_base_form,
			         affix_tree_chain);
	    else
		if (normalize) {
		    print_out("\"");
		    print_string(outfile, current_string);
		    if (current_string != current_base_form
		        && strcmp((char *) current_string,
			          (char *) current_base_form)) {
			print_out("\" = \"");
			print_string(outfile, current_base_form);
		    }
		    print_out("\"\n");
		}
	    parsing=TRUE;
	    if (current_string != current_base_form)
		MY_FREE(current_base_form);
	    MY_FREE(current_string);
	}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 880 "user.y"
    {
		/* TODO should not be in the lexical alphabet but user */
		current_base_form = (yyvsp[(2) - (2)].letter_string);
	    }
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 885 "user.y"
    {
		current_base_form = current_string;
	    }
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 891 "user.y"
    {
	    /* save string */
	    current_string = (yyvsp[(1) - (1)].letter_string);
	}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 897 "user.y"
    {

	}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 901 "user.y"
    {

	}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 907 "user.y"
    {
		defined_symbol=NULL; /* end of definitions */
		allow_string_letters=FALSE;
	     }
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 914 "user.y"
    {
		t_str filler_symbol_name;

		defined_kind=Alphabet;
		init_symbol_set(&symbol_set[Pair], Lexical_Letter);
		/* fill the slot with ordinal number 0 with a dummy symbol
		   so that letter strings can also terminate with 0;
		   Use strdup, just in case the symbol is freed one day.
                 */
		MY_STRDUP(filler_symbol_name,""); /* impossible symbol name */
		(void) new_symbol(filler_symbol_name,&symbol_set[Pair]);
		/*  declare word boundary and morpheme boundary */
		MY_STRDUP(filler_symbol_name," + "); /* unlikely symbol name */
		morpheme_boundary_pair
		    = (s_pair *) (*new_symbol(filler_symbol_name,
				   &symbol_set[Pair]))->data;
		morpheme_boundary = morpheme_boundary_pair->lexical;
		/* tinker with the symbol table */
		morpheme_boundary_pair->surface= empty_string;
		first_lexical_letter=*morpheme_boundary;
		MY_STRDUP(filler_symbol_name," ~ "); /* unlikely symbol name */
		word_boundary_pair
		    = (s_pair *) (*new_symbol(filler_symbol_name,
				   &symbol_set[Pair]))->data;
		word_boundary=word_boundary_pair->lexical;
		/* tinker with the symbol table */
		word_boundary_pair->surface= empty_string;
		allow_string_letters=TRUE; /* allow ASTRING strings */
		MY_CALLOC(surface_letter_map,LETTER_MAP_SIZE,t_letter);
		MY_CALLOC(lexical_letter_map,LETTER_MAP_SIZE,t_letter);
		MY_CALLOC(letter_to_char_map,LETTER_MAP_SIZE,unsigned char);
		crc32file_addn(&crc, (unsigned char *) "@Alphabets ",
		               sizeof("@Alphabets "));
	     }
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 951 "user.y"
    {
		MY_FREE(fake_symbol.name);
		alphabet_size=symbol_set[Pair].card;
		make_symbol_reference(&symbol_set[Pair]);
		if (debug & DEBUG_INIT) {
		    print_symbols_by_ref(&symbol_set[Pair]);
		}
	     }
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 962 "user.y"
    {
		/* don't care about name, first is lexical, second surface */
		fake_symbol.name=(yyvsp[(1) - (1)].string);
		fake_symbol.ordinal=0;
		defined_symbol=&fake_symbol;
		symbol_set[Pair].kind = Lexical_Letter;
		current_letter_map=lexical_letter_map;
		crc32file_addn(&crc, (unsigned char *) "Lexical:",
			       sizeof("Lexical:"));
	     }
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 975 "user.y"
    {
		/* don't care about name, first is lexical, second surface */
		defined_kind=Alphabet;
		MY_FREE(fake_symbol.name);
		fake_symbol.name=(yyvsp[(1) - (1)].string);
		fake_symbol.ordinal=0;
		symbol_set[Pair].kind = Surface_Letter;
		current_letter_map=surface_letter_map;
		lexical_alphabet_size=symbol_set[Pair].card;
		crc32file_addn(&crc, (unsigned char *) "Surface:",
			       sizeof("Surface:"));
	     }
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 990 "user.y"
    {
	    }
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 993 "user.y"
    {
	    }
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 998 "user.y"
    {
		s_symbol *symbol;
		int	  length;

		symbol= *new_symbol((yyvsp[(1) - (1)].string),&symbol_set[Pair]);
		if ((length = strlen(symbol->name)) == 1) {
		    current_letter_map[(unsigned char) *symbol->name]
			    = (t_letter) symbol->ordinal;
		    letter_to_char_map[symbol->ordinal]
			    = (unsigned char) *symbol->name;
		}
		crc32file_addn(&crc, (unsigned char *) (yyvsp[(1) - (1)].string) , (int) length);
		crc32file_add(&crc, (unsigned char) ' ');
	    }
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 1013 "user.y"
    { 	/* allow special characters to be declared  as letter */
		/* TODO: cleanup the cases where this name could be printed */
		s_symbol *symbol;
		
		symbol= *new_symbol((yyvsp[(1) - (1)].string),&symbol_set[Pair]);
		if (strlen(symbol->name) != 1)
			fatal_error("%s %s %s",
			    "Sorry: cannot accept string definition of",
			    symbol_kind_str[current_letter_kind],
			    "longer than one character");
		 else {
		    current_letter_map[(unsigned char) *symbol->name]
			    = (t_letter) symbol->ordinal;
		    letter_to_char_map[symbol->ordinal]
			    = (unsigned char) *symbol->name;
		}
		crc32file_add(&crc, (unsigned char) '"');
		crc32file_add(&crc, (unsigned char) *(yyvsp[(1) - (1)].string));
		crc32file_add(&crc, (unsigned char) '"');
	    }
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 1036 "user.y"
    {
		defined_symbol=NULL; /* end of definitions */
		    if (debug & DEBUG_INIT) { /* TODO change this */
			print_symbol_table(&symbol_set[Pair]);
		    }
		MY_FREE(current_lexical_set);
	    }
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 1044 "user.y"
    {
	    }
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 1049 "user.y"
    {
		defined_kind=Pair;
		symbol_set[Pair].kind = Pair; 
		current_lexical_set=new_bitmap((long) alphabet_size);
	    }
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 1057 "user.y"
    {
		
	    }
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 1061 "user.y"
    {
	    }
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 1066 "user.y"
    {
		defined_symbol=NULL; /* for error message */
	    }
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 1072 "user.y"
    {
		defined_symbol = *new_symbol((yyvsp[(1) - (1)].string),&symbol_set[Pair]);

		current_pair = (s_pair *) defined_symbol->data;
		/* next letter will be found in surface alphabet */
		current_letter_kind=Surface_Letter;
		current_letter_map=surface_letter_map;
		current_pair_flags=BOTH_LETTERS; /* for next explicit Pair */
		empty_bitmap(current_lexical_set);
		current_pair_width=-1;
	    }
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 1086 "user.y"
    {
	    }
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 1089 "user.y"
    {
	    }
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 1094 "user.y"
    {
		int lexical_width;

		if (current_pair_flags & LEXICAL_IS_CLASS)
		    lexical_width=1;
		else 
		    lexical_width=strlen((char *) (yyvsp[(3) - (3)].letter_string));
		if (lexical_width > 1) { /* TODO: print pair */
		    fatal_error("%s\nthe lexical part %s",
			    "Sorry, not yet implemented.", 
			    "of the pair cannot be longer than one symbol");
		}
		if (current_pair_width == -1)
		    current_pair_width = lexical_width;
		else
		    if (current_pair_width != lexical_width)
			fatal_error("%s %s",
				    "you cannot mix pairs with different",
				    "lexical lengths");
		if (lexical_width==0
		    && !(current_pair_flags & SURFACE_IS_CLASS)
		    && *((yyvsp[(1) - (3)].letter_string)) == NUL_LETTER)
		    fatal_error("empty pair <>/<> is not allowed");
		add_explicit_pair(current_pair,(yyvsp[(1) - (3)].letter_string),(yyvsp[(3) - (3)].letter_string),current_pair_flags,
				  current_lexical_set);
		current_pair_flags=BOTH_LETTERS; /* restore for next */
	    }
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 1122 "user.y"
    {
		int pair_width;

		/* TODO factorize this code and similar above */
		if ((yyvsp[(1) - (1)].symbol) == defined_symbol)
		    fatal_error("pair name is used in its own definition");
		pair_width=lexical_width((s_pair *) (yyvsp[(1) - (1)].symbol)->data);
		if (current_pair_width == -1)
		    current_pair_width = pair_width;
		else
		    if (current_pair_width != pair_width)
			fatal_error("%s %s",
				    "you cannot mix pairs with different",
				    "lexical lengths");
		add_pair(current_pair, (s_pair *) (yyvsp[(1) - (1)].symbol)->data,
			 current_lexical_set);
	    }
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 1142 "user.y"
    { /* similar to Pair above */
		int lexical_width;

		if (! (current_pair_flags & LEXICAL_IS_CLASS)) {
		    lexical_width=strlen((char *) (yyvsp[(3) - (3)].letter_string));
		    if (lexical_width > 1) /* TODO: print pair */
			fatal_error("%s\nthe lexical part of th pair %s",
				"Sorry, not yet implemented.", 
				"cannot be longer than one symbol");
		    else
			if (lexical_width == 0
			    && ! (current_pair_flags & LEXICAL_IS_CLASS)
			    && *((yyvsp[(1) - (3)].letter_string)) == NUL_LETTER)
			    fatal_error("empty pair <>/<> is not allowed");
		}
		(yyval.pair)=new_pair((yyvsp[(1) - (3)].letter_string),(yyvsp[(3) - (3)].letter_string),current_pair_flags,(s_pair *) NULL);
		if (within_focus)
		    is_pair_concrete((yyval.pair));
		current_pair_flags=BOTH_LETTERS; /* restore for next */
	    }
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 1163 "user.y"
    {
		(yyval.pair)= (s_pair *) (yyvsp[(1) - (1)].symbol)->data;
		if (within_focus)
		    is_pair_concrete((yyval.pair));
	    }
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 1172 "user.y"
    {
		(yyval.symbol)= *find_symbol((yyvsp[(1) - (1)].string),&symbol_set[Pair]);
		if (! ((yyval.symbol)->kind == Pair
		       || (yyval.symbol)->kind == Pair_Letter
		       || (yyval.symbol)->kind == Pair_Class))
		    fatal_error("%s \"%s\"",
				"There is no pair associated to symbol",
				(yyval.symbol)->name);
	    }
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 1184 "user.y"
    {
		current_letter_kind=Lexical_Letter; /* alternate */
		current_letter_map=lexical_letter_map;
		(yyval.letter_string)=(yyvsp[(1) - (1)].letter_string);
	    }
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 1192 "user.y"
    {
		current_letter_kind=Surface_Letter; /* alternate */
		current_letter_map=surface_letter_map;
		(yyval.letter_string)=(yyvsp[(1) - (1)].letter_string);
	    }
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 1200 "user.y"
    {
		letter_string[letter_string_size]= NUL_LETTER;
		MY_STRDUP((yyval.letter_string),letter_string);
	    }
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 1205 "user.y"
    {
		(yyval.letter_string)= (t_letter *) (yyvsp[(1) - (1)].letter_string);
	    }
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 1209 "user.y"
    {
		s_symbol   *pair_symbol;

		pair_symbol = *find_symbol((yyvsp[(1) - (1)].string), &symbol_set[Pair]);
		if (pair_symbol->kind== Pair
		    || (current_letter_kind == Surface_Letter
			&& (pair_symbol->kind == Lexical_Letter
			    || pair_symbol->kind == Lexical_Class))
		    || (current_letter_kind == Lexical_Letter
			&& (pair_symbol->kind == Surface_Letter
			    || pair_symbol->kind == Surface_Class)))
		    fatal_error("symbol \"%s\" is not a %s",
				pair_symbol->name,
				symbol_kind_str[current_letter_kind]);
		if (pair_symbol->data->pair.pair_flags == BOTH_CLASSES)
		    if (current_letter_kind == Surface_Letter)
			current_pair_flags |= SURFACE_IS_CLASS;
		    else
			current_pair_flags |= LEXICAL_IS_CLASS;
		if (current_letter_kind == Surface_Letter)
		    (yyval.letter_string) = pair_symbol->data->pair.surface;
		else
		    (yyval.letter_string) = pair_symbol->data->pair.lexical;
	    }
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 1234 "user.y"
    {
		(yyval.letter_string) = letter_any;
	    }
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 1240 "user.y"
    {
		if (letter_string_size >= LETTER_STRING_SIZE_MAX - 1)
		    fatal_error("symbol sequence too long, maximum=%d",
				LETTER_STRING_SIZE_MAX - 1);
		letter_string[letter_string_size++]
		    = *find_letter((yyvsp[(2) - (2)].string), current_letter_kind);
	    }
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 1248 "user.y"
    {
		letter_string_size=0;
	    }
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 1255 "user.y"
    {
		    defined_symbol=NULL; /* end of definitions */
		    allow_string_letters=FALSE;
		    if (debug & DEBUG_INIT) { /* TODO change this */
			print_symbol_table(&symbol_set[Pair]);
		    }
		}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 1263 "user.y"
    {
		}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 1267 "user.y"
    {
		defined_kind=Pair_Class;
		symbol_set[Pair].kind = Pair_Class;
		allow_string_letters=TRUE;
	    }
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 1275 "user.y"
    {
	    }
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 1278 "user.y"
    {
	    }
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 1283 "user.y"
    {
		if (class_flags & SURFACE_FLAG)
		    if (class_flags & LEXICAL_FLAG) {
			defined_symbol->kind=Pair_Class;
			defined_symbol->data->class.lexical = current_class;
		    }
		    else
			defined_symbol->kind=Surface_Class;
		else {
		    defined_symbol->kind = Lexical_Class;
		    defined_symbol->data->class.lexical = current_class;
		    defined_symbol->data->class.surface = NULL;
		}
		defined_symbol=NULL; /* for error message */
	    }
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 1301 "user.y"
    {
		defined_symbol = *new_symbol((yyvsp[(1) - (1)].string),&symbol_set[Pair]);
		current_class = defined_symbol->data->class.surface;
		class_flags = SURFACE_FLAG | LEXICAL_FLAG;
	    }
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 1309 "user.y"
    {
	    }
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 1312 "user.y"
    {
	    }
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 1317 "user.y"
    {
	  s_symbol *class_symbol;

	  class_symbol = *find_symbol((yyvsp[(1) - (1)].string),&symbol_set[Pair]);
	  switch (class_symbol->kind) {
	      case Surface_Letter:
		      class_flags &= SURFACE_FLAG;
		      set_bit(current_class,
			      (long) *(class_symbol->data->pair.surface));
		      break;
	      case Lexical_Letter:
		      class_flags &= LEXICAL_FLAG;
	      /*FALLTHROUGH*/
	      case Pair_Letter:
		      set_bit(current_class,
			      (long) *(class_symbol->data->pair.lexical));
		      break;
	      case Surface_Class:
		      class_flags &= SURFACE_FLAG;
		      assign_or(current_class,
				class_symbol->data->class.surface);
		      break;
	      case Lexical_Class:
		      class_flags &= LEXICAL_FLAG;
	      /*FALLTHROUGH*/
	      case Pair_Class:
		      if (class_symbol == defined_symbol)
			fatal_error(
			"symbol class is used in its own definition");
		      assign_or(current_class,
				class_symbol->data->class.lexical);
		      break;
	      default:
		      fatal_error("program bug: no such class kind");
		      break;	
	  }
	  if (class_flags == 0)
		fatal_error("you cannot mix %s (class=\"%s\", symbol=\"%s\")",
			    "pure lexical and surface symbols in same class",
			    defined_symbol->name,
			    class_symbol->name);
      }
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 1360 "user.y"
    { /* allow special characters to be used as a class definition */
	/* TODO: cleanup the cases where this name could be printed ?? */
	s_symbol *class_symbol;

	class_symbol= *find_symbol((yyvsp[(1) - (1)].string),&symbol_set[Pair]);
	switch (class_symbol->kind) {
	    case Surface_Letter:
		    class_flags &= SURFACE_FLAG;
		    set_bit(current_class,
			    (long) *(class_symbol->data->pair.surface));
		    break;
	    case Lexical_Letter:
		    class_flags &= LEXICAL_FLAG;
	    /*FALLTHROUGH*/
	    case Pair_Letter:
		    set_bit(current_class,
			    (long) *(class_symbol->data->pair.lexical));
		    break;
	    default:
		    fatal_error("program bug: no such class kind");
		    break;	
	}
	if (class_flags == 0)
	      fatal_error("%s %s (class=\"%s\", symbol=\"%s\")",
			  "you cannot mix pure lexical and surface",
			  "symbols in the same class",
			  defined_symbol->name,
			  class_symbol->name);
      }
    break;



/* Line 1455 of yacc.c  */
#line 3401 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



